\ R.Hempel 22Mar2002 Clean up comments for release
\ This work is based on Chris Jakeman's MAF and PAF Forth systems. Their
\ goal was to build a minimal ANS Forth that could be built by a standard
\ Forth system and made no assumptions about the underlying achitecture.
\ J.Bezemer 26Apr2007 4tH version

[UNDEFINED] digit? [IF]
[needs lib/digit.4th]
[THEN]

[UNDEFINED] mu* [IF]
[needs lib/mixed.4th]
[THEN]

[UNDEFINED] >double [IF]
: 0. 0 dup ;                           ( -- d1)

\ ud1 is the unsigned result of converting the string into digits using
\ the current base and adding each into ud1 after multiplying ud1 by the base.
 
: >double                              ( ud1 a1 u1 -- ud2 a2 u2)
  >r                                   ( u1 u2 a1 )                              
  begin                                ( u1 u2 a1 )
    dup r@                             ( u1 u2 a1 a1 u3)
  while                                ( u1 u2 a1 a1)
    c@ digit?                          ( u1 u2 a1 u3 f)
  while                                ( u1 u2 a1 u3)
    swap >r >r                         ( u1 u2)
    base @ mu* r> 0 d+ r> char+        ( u1 u2 a1)
    r> 1- >r                           ( u1 u2 a1)
  repeat                               ( u1 u2 a1)
  drop r>
;

[UNDEFINED] >number [IF]               \ create the alias >NUMBER
aka >double >number                    \ if it hasn't been defined already
[THEN]
[THEN]
